(define (board_ref board x y)
  (vector-ref board (+ x (* 8 y))))

(define (oth_reverse board pos col)
  (define (reverse_dir board x y xd yd)
    (define (iter x y)
      (if (and (<= 0 x 7) (<= 0 y 7))
	  (let ((p (board_ref board x y)))
	    (cond 
	     ((= p 0) -63) ; small enough to send imposible
	     ((= p col) 0)
	     (else (1+ (iter (+ x xd) (+ y yd))))))
	  -63))
    ;       (trace iter)
    (max 0 (iter (+ x xd) (+ y yd))))

;  (trace reverse_dir)

  (if (= 0 (vector-ref board pos))
      (let ((x (remainder pos 8))
	    (y (quotient pos 8)))
	(+ (reverse_dir board x y -1 -1)
	   (reverse_dir board x y -1 0)
	   (reverse_dir board x y -1 1)
	   (reverse_dir board x y 0 -1)
	   (reverse_dir board x y 0 1)
	   (reverse_dir board x y 1 -1)
	   (reverse_dir board x y 1 0)
	   (reverse_dir board x y 1 1)))
      0))

(define (think board passp)
  (define (iter i m mp)
    (if (> i 63) mp
	(let ((result (oth_reverse board i 1)))
	  (if (< 0 result m)
	      (iter (1+ i) result i)
	      (iter (1+ i) m mp)))))
  (if (= 1 passp) -1
      (iter 0 9 0)))

;(trace think oth_reverse)

(define (init)
;  (display "start\n" (current-error-port))
  (read)
;  (display "init packet read ... " (current-error-port))
  (display "OK")(newline)
;  (display "result sent\n" (current-error-port))
)

(define (main-loop)
  (let ((input (read)))
;    (display "data packet read ... " (current-error-port))
    (if (eof-object? input)
	0
	(begin
	  (write (apply think input))(newline)
;	  (display "result sent\n" (current-error-port))
	  (main-loop)))))

(init)
(main-loop)